#define PATH_TO_SOUND "/root/compile/vsound/sounds/"

#include <stdio.h>
#include <stdlib.h>
#include <values.h>
#include <string.h>
#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include "defs.h"
#include "pc_keys.h"
#include "grafix.h"
#include "vga_13.h"
#include "traveler.h"
#include "pen.h"
#include "convpoly.h"
#include "vmath.h"
#include "port_3d.h"
#include "cpoly.h"
#include "copoly.h"
#include "font8x8.h"
#include "flight.h"
#include "fltlite.h"
#include "weapons.h"
#include "unguided.h"
#include "bits.h"
#include "zview.h"
#include "fltzview.h"
#include "simfile.h"
#include "pilot.h"
#include "fltmngr.h"
#include "rtkey.h"
#include "sim.h"
#include "input.h"
#include "globals.h"
#include "siminput.h"
#include "colorspc.h"
#include "earth.h"
#include "hud.h"

#include <stddef.h>
#include <errno.h>
#include <sys/socket.h>
#include <sys/un.h>
     

#include "soundcontrol.h"

#define SERVER "/tmp/serversocket"
#define CLIENT "/tmp/mysocket"
#define MAXMSG 1024


int sound_control(int mode, float value)
{
int a;
extern int make_named_socket(const char *name);
static int sock;
char message[MAXMSG];
static struct sockaddr_un name;
static size_t size;
int nbytes;
char temp[1024];
static int socket_created_flag;
FILE *fptr;
static int old_mode;
static float old_value;
float fa;
static int jet;
int send_it;
static float old_wind_value;
static float old_jet_value;
char path_to_sound[1024];

/*fprintf(stdout, "XXXmode=%d value=%.2f\n", mode, value);*/

strcpy(path_to_sound, PATH_TO_SOUND);

if(! socket_created_flag)
	{
	/* remove any old socket */
	sprintf(temp, "rm /tmp/mysocket\n");
	fptr = popen(temp, "r");
	pclose(fptr);

	/* Make the socket. */
	sock = make_named_socket(CLIENT);

	/* Initialize the server socket address. */
	name.sun_family = AF_UNIX;
	strcpy(name.sun_path, SERVER);
	size = strlen(name.sun_path) + sizeof(name.sun_family);

	socket_created_flag = 1;
	}/* end if ! socket created_flag */

/*
If we receive a CANNON_SOUND od GUN_SOUND interrupt current, play cannon or
gun at correct (file) speed, no loop
*/

select_sound:
/* the format is pathfilename:speed:volume:offset:length:loop */
switch(mode)
	{
	case CANNON_SOUND:
		/* always play file as is, always maximum volume, no loop */
		sprintf(temp,\
		"%s/exp.wav:0:100:0:0:0", path_to_sound);

		old_mode = mode;
		break;
	case GUN_SOUND:	
		/* always play file as is, always max volume, no loop */
		sprintf(temp,\
		"%s/gun.wav:0:100:0:0:0", path_to_sound);

		old_mode = mode;
		break;
	case JET_SOUND:
		send_it = 0;
		if(old_mode == CANNON_SOUND) send_it = 1;
		if(old_mode == GUN_SOUND) send_it = 1;

		if(value != old_jet_value)
			{
			send_it = 1;
			old_jet_value = value;
			}
		if(value < 11) send_it = 0;

		old_mode = mode;
		if(! send_it) return(1);
		
		/* 0 to 100 */
		a = 4000 + 100 * (int) value;
		sprintf(temp,\
		"%s/jet_int.wav:%d:100:0:0:1",\
		path_to_sound, a);
		break;
	case WIND_SOUND:
		/* 0 to 700 */
		send_it = 0;
		if(old_mode == CANNON_SOUND) send_it = 1;
		if(old_mode == GUN_SOUND) send_it = 1;
		/* 0 to 700 */
		if(fabs(value - old_wind_value) > 10.0)
			{
			send_it = 1;
			old_wind_value = value;
			}

		/* no wind if jet */
		if(old_jet_value > 10) send_it = 0;
		old_mode = mode;
		if(! send_it) return(1);

		/* 0 to 500 */
		a = 4000 + 20 * (int) value;

		/*fprintf(stdout, "CALCULATED=%d\n", a);*/

		sprintf(temp,
		"%s/wind_int.wav:%d:100:0:0:1",\
		path_to_sound, a);
		break;
	default:
		return(1);
		break;
	}/* end switch mode */

/* Send the datagram. */
nbytes = sendto(sock, temp, strlen(temp) + 1, 0,\
(struct sockaddr *) & name, size);
if(nbytes < 0)
	{
	perror("sendto (client)");
	return(0);
	}

if( (mode == GUN_SOUND) || (mode == CANNON_SOUND) )
	{
	if(old_jet_value > 10)/* have jet */
		{
		value = old_jet_value + 1.0; 
		mode = JET_SOUND;
		}
	else
		{
		value = old_wind_value + 11.0;
		mode = WIND_SOUND;
		}
	goto select_sound;
	}

return(1);
}/* end function sound_control */


int make_named_socket(const char *filename)
{
struct sockaddr_un name;
int sock;
size_t size;
 
/* Create the socket. */
sock = socket(PF_UNIX, SOCK_DGRAM, 0);
if(sock < 0)
	 {
	perror("socket");
	exit(EXIT_FAILURE);
	}

/* Bind a name to the socket. */

name.sun_family = AF_UNIX;
strcpy(name.sun_path, filename);

/*
The size of the address is
the offset of the start of the filename,
plus its length,
plus one for the terminating null byte. 
*/

size = offsetof(struct sockaddr_un, sun_path) + strlen(name.sun_path) + 1;

if(bind(sock, (struct sockaddr *) &name, size) < 0)
	{
	perror("bind");
	exit(EXIT_FAILURE);
	}

return sock;
}/* end function make_named_socket */


